'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Duce = (_temp = _class = function Duce() {
  var _this = this;

  _classCallCheck(this, Duce);

  this.defaultState = {};
  this.state = {};

  this.replace = function (value) {
    return value;
  };

  this.set = function (key, value) {
    return _extends({}, _this.state, _defineProperty({}, key, value));
  };

  this.delete = function (key) {
    return _lodash2.default.omit(_this.state, key);
  };

  this.union = function (key, value) {
    return _extends({}, _this.state, _defineProperty({}, key, _lodash2.default.union(_this.state[key], _lodash2.default.flatten([value]))));
  };

  this.without = function (key, value) {
    return _extends({}, _this.state, _defineProperty({}, key, _lodash2.default.without(_this.state[key], value)));
  };

  this._functionMap = function () {
    var functions = _lodash2.default.omit(_lodash2.default.keyBy(_lodash2.default.functions(_this)), Duce.RESERVED_FUNCTIONS);
    var functionNames = _lodash2.default.mapKeys(functions, function (value, key) {
      return _lodash2.default.toUpper(_lodash2.default.snakeCase(key));
    });
    return _lodash2.default.mapValues(functionNames, function (value) {
      return _this[value];
    });
  };

  this.reduce = function () {
    var functionMap = _lodash2.default.memoize(_this._functionMap)();

    return function () {
      var state = arguments.length <= 0 || arguments[0] === undefined ? _this.defaultState : arguments[0];
      var action = arguments[1];

      if (!functionMap[action.type]) return state;
      _this.state = state;
      return functionMap[action.type](action.payload);
    };
  };
}, _class.RESERVED_FUNCTIONS = ['set', 'reduce', 'delete', 'replace', '_functionMap'], _class.reducer = function () {
  return new this().reduce();
}, _temp);
exports.default = Duce;